<template>
  <v-container class="pa-0" v-if="showDocuments()">
    <v-container class="pa-2 doc-wrapper">
      <div class="mt-8 d-flex flex-column align-center">
        <v-badge class="mb-2" :class="{ 'badge-success': isDocumentsFinalized }" dot offset-x="-5" offset-y="-5">
          <v-icon size="24">description</v-icon>
        </v-badge>
        <span class="text-center">Documents avion</span>
      </div>
      <v-btn v-show="!docList" icon class="doc-open" data-cy="FlightDocumentsOpenBtn" @click="docList = !docList"
        variant="outlined" size="small">
        <v-icon>navigate_before</v-icon>
      </v-btn>
    </v-container>
    <v-navigation-drawer v-model="docList" location="right" :width="350" temporary>
      <v-btn v-show="docList" icon class="doc-open" data-cy="FlightDocumentsCloseBtn" @click="docList = !docList"
        variant="outlined" size="small">
        <v-icon>navigate_next</v-icon>
      </v-btn>
      <v-container class="pa-5">
        <div class="mb-3 d-flex align-center">
          <v-icon class="mr-2">description</v-icon>
          <span class="font-weight-bold text-subtitle-1">Documents avion</span>
          <v-spacer></v-spacer>
          <v-btn icon flat data-cy="FlightDocumentsDownloadFlightBtn"
            @click="downloadFile({ filename: `${flight.id}.zip` }, flight.id)" class="ml-2">
            <v-icon>file_download</v-icon>
          </v-btn>
        </div>
        <FlightsFlightDocumentsList :documentsObject="flight.documents" :documentsName="flightDocuments"
          @download="downloadFile($event, flight.id)" />

        <v-divider class="mt-2"></v-divider>
        <div v-for="(leg, index) in flight.legs" :key="index">
          <div class="mt-2 mb-2 d-flex align-center font-weight-bold" v-if="leg.id">
            <v-avatar size="32" class="mr-4 outlined">
              {{ index + 1 }}
            </v-avatar>
            {{ leg.departure.oaci }} > {{ leg.arrival.oaci }}
            <v-spacer></v-spacer>
            <v-chip class="ml-4 text-uppercase status-chip" label :class="getStatusClass(leg.status)">
              {{ legStatus[leg.status] }}
            </v-chip>
            <v-btn icon flat data-cy="FlightDocumentsDownloadLegBtn"
              @click="downloadFile({ filename: `${flight.id}_${leg.id}.zip` }, flight.id, leg.id)" class="ml-2">
              <v-icon>file_download</v-icon>
            </v-btn>
          </div>

          <FlightsFlightDocumentsList :documentsObject="leg.documents" :documentsName="documents"
            @download="downloadFile($event, flight.id, leg.id)" />
        </div>
      </v-container>
    </v-navigation-drawer>
  </v-container>
</template>

<script setup lang="ts">
import { getStatusClass } from "../mixins/utilsMixin";
import { LegStatus } from "~/dto/legstatus.enum";
import { Flight } from "~/dto/flight.dto";

const props = defineProps<{ flight: Flight }>()

const { $api, $toast } = useNuxtApp();
const docList = ref(false);
const isDocumentsFinalized = computed(() => {
  return props.flight.legs.some(l => l.status !== 'finalized')
});

const legStatus = LegStatus
const flightDocuments = ['cover']
const documents = ['paxManifest', 'paxManifestLmc', 'animalManifest', 'animalManifestLmc', 'workSheet', 'workSheetLmc', 'paxXlsx', 'tickets', 'ticketsLmc',
  'tm5', 'tm5Lmc', 'pnl', 'pnlLmc', 'cover', 'seats']

const showDocuments = (): boolean => {
  // REFACTO: I redo the code to use modern way (some) 
  return documents.some((d: string) => {
    if (d in (props.flight?.documents || [])) {
      return true
    }

    return props.flight.legs?.some(l => d in (l?.documents || []));
  });
}

const downloadFile = async (doc: any, flightId: number, legId: number | null = null) => {
  try {
    const response = !legId ? (!doc.id ? await $api.flightDocuments.getDocuments(flightId) :
      await $api.flightDocuments.getOneDocument(flightId, doc.id)) :
      !doc.id ? await $api.legDocuments.getDocuments(flightId, legId) :
        await $api.legDocuments.getOneDocument(flightId, legId, doc.id);
        const disposition = response.headers['content-disposition'];

    if (!response || !response._data) {
      $toast.error("Le fichier n'existe pas");
      return;
    }
    const file = response._data;
    const fileName = disposition ? disposition.split('filename="')[1].split('"')[0] : doc.filename;
    const fileURL = window.URL.createObjectURL(new Blob([file]));
    const fileLink = document.createElement('a');

    fileLink.href = fileURL;
    fileLink.setAttribute('download', fileName);
    document.body.appendChild(fileLink);

    fileLink.click();
  } catch (e) {
    console.log(e)
    $toast.error("Erreur lors du téléchargement du fichier");
  }
}


</script>

<style lang="scss">
@import "../../assets/variables.scss";

.doc-open.v-btn {
  border-color: $grey-light;
  background-color: $color-white;
  position: absolute;
  top: 40px;
  left: -18px;
}

.badge-success .v-badge__badge {
  background-color: #358f54 !important;
}

#app .doc-wrapper {
  position: fixed;
  right: 0;
  top: 80px;
  width: 75px;
  height: calc(100% - (80px + 58px)); // header + footer
  background-color: $color-white;
  border-left: 1px solid $grey-ultra-light;
  font-size: 0.7rem;

  .doc-open.v-btn {
    color: $grey-light;
  }
}

#app .v-navigation-drawer {
  .doc-open.v-btn {
    z-index: 100;
    color: $grey-light;
  }
}
</style>

